Request for vCloud Director support
Assignee: Adam Heinz   

Category: Compute resources   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

It would be great to use vcloud director in Foreman. Support is being added to fog which means a model for this compute resource in

Foreman is now possible.

https://github.com/fog/fog/search?q=director&ref=cmdform

Related issues:

Is duplicate of Foreman - Feature #22346: Vmware VCloud Director Support Needs design

History

#1 - 10/04/2013 03:32 PM - Dominic Cleal

- Category set to Compute resources

#2 - 11/05/2013 03:36 PM - Ewoud Kohl van Wijngaarden

It seems we might switch to vCloud as well. Since I'm new to vCloud, it would be helpful to at least get some general idea what's what. Please correct

me where I'm wrong.

A VM is always part of a vApp.

A vApp is a collection of one or more VMs

vCloud can manage your IPs for you and be the DHCP server

To create a VM, you could do bare metal provisioning but I think there's also some image management using vApps. I'm having a hard time finding

information (as always with VMware), so any additional information would be helpful.

#3 - 11/06/2013 09:10 PM - Adam Heinz

- Assignee set to Adam Heinz

- translation missing: en.field_release set to 2

#4 - 11/08/2013 10:11 PM - Adam Heinz

I have fog 1.18 up and running on a CentOS 6 box using the ruby193 software collection.  I've been experimenting with it from the command line, but

haven't been able to instantiate anything smaller than a vApp.  Inspecting 

VcloudDirector.organizations.first.catalogs.first.catalog_items.first

in fog, the vApp template is opaque, preventing me from instantiating an individual VM.  I am able to add virtual machines to a vApp from the web

app, but this functionality might not be available in the API.  Reading through the vCloud API Programming Guide for vCloud Director 5.5 hasn't

provided any enlightenment.

#5 - 01/06/2014 09:15 PM - Adam Heinz

- Status changed from New to Closed

- translation missing: en.field_release deleted (2)

After thorough review of the documentation and experimentation, I don't think this integration is feasible.  Perhaps the necessary functionality will be

added to the vCloud API in some version after 5.5, but it is not currently possible to instantiate a single virtual machine without some sort of horrific

clone+recompose+recompose daisy chain.
https://github.com/fog/fog/search?q=director&ref=cmdform
http://pubs.vmware.com/vcd-55/topic/com.vmware.ICbase/PDF/vcd_55_api_guide.pdf


#6 - 01/07/2014 10:06 AM - Ewoud Kohl van Wijngaarden

Looking at https://github.com/fog/fog/blob/master/lib/fog/vcloud_director/README.md, it may be easier to just support vCloud as an image-based

compute resource. I think a vApp. That said, I think you only want to support vApps with a single VM to map properly to the foreman model.

#7 - 01/07/2014 05:52 PM - Kal Aeolian

This would be almost hackish but would work for single-vm apps. It would be interesting to map an application definition to a 'vapp' equivalent in

Foreman. We currently use 30+ different app/db servers (each with its own hostgroup/puppet classes/etc) and this constitutes a single application in

line with what VMware calls a vapp. They are logically separated by a parent hostgroup. For us adding a VM to a 'vapp' means adding a new VM to a

'hostgroup' parent or parent's child (i.e. if we add a new cluster member to a 'prd/cluster' child it means adding a new vm to vapp 'prd'.

I don't know if this model can be extended onto a vapp via fog (or if any of the other compute resources have a similar definition on a application

group like a vapp) or if this is even a feature that would be in line with what Foreman is trying to accomplish.

#8 - 01/22/2018 01:38 PM - Anonymous

- Is duplicate of Feature #22346: Vmware VCloud Director Support added
